CREATE OR REPLACE TRIGGER LOG_CMP_ITEMSOLI
AFTER INSERT OR UPDATE
ON ITEMSOLI FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_IDPARAM      VARCHAR2(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   SELECT NVL(MAX(IDUTAPROVSOL), 'N')
     INTO V_IDPARAM
    FROM PARCMPSUP
   WHERE CDFILIAL = NVL(:NEW.CDFILSOLI, :OLD.CDFILSOLI);

   IF UPDATING THEN
      IF (NVL(:OLD.DTPROGENTR, TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:NEW.DTPROGENTR, TO_DATE('01/01/1900', 'DD/MM/YYYY'))) THEN
         V_DESC := V_DESC ||'Dt. Entr. Item' ||''|| NVL(:NEW.DTPROGENTR,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDOPERAPROV, 'X') <> NVL(:NEW.CDOPERAPROV, 'X')) THEN
         V_DESC := V_DESC ||'Oper. Aprova.' ||''|| NVL(:NEW.CDOPERAPROV,'') ||'   ';
      END IF;
      IF (NVL(:OLD.DTUTILIZA, TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:NEW.DTUTILIZA, TO_DATE('01/01/1900', 'DD/MM/YYYY'))) THEN
         V_DESC := V_DESC ||'Dt. Ut.' ||''|| NVL(:NEW.DTUTILIZA,'') ||'   ';
      END IF;
      IF (NVL(:OLD.QTSOLIPROD, 0) <> NVL(:NEW.QTSOLIPROD, 0)) THEN
         V_DESC := V_DESC ||'Qt. Itens:' ||''|| NVL(:NEW.QTSOLIPROD,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDITMCONS, 'X') <> NVL(:NEW.IDITMCONS, 'X')) THEN
         V_DESC := V_DESC ||'ID Cons:' ||''|| NVL(:NEW.IDITMCONS,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDSOLIAPROV, 'X') <> NVL(:NEW.IDSOLIAPROV, 'X')) THEN
         V_DESC := V_DESC ||'ID Aprovao:' ||''|| NVL(:NEW.IDSOLIAPROV,'') ||'   ';
      END IF;
      IF (NVL(:OLD.DTHRAPROVSOL, TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:NEW.DTHRAPROVSOL, TO_DATE('01/01/1900', 'DD/MM/YYYY'))) THEN
         V_DESC := V_DESC ||'Dt. Aprovao:' ||''|| NVL(:NEW.DTHRAPROVSOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDFILIOPELOG, 'X') <> NVL(:NEW.CDFILIOPELOG, 'X')) THEN
         V_DESC := V_DESC ||'Filial OL:' ||''|| NVL(:NEW.CDFILIOPELOG,'') ||'   ';
      END IF;
      IF (NVL(:OLD.NRSEQUCONSOL, 'X') <> NVL(:NEW.NRSEQUCONSOL, 'X')) THEN
         V_DESC := V_DESC ||'Consolidao:' ||''|| NVL(:NEW.NRSEQUCONSOL,'') ||'   ';
      END IF;
      IF (NVL(V_IDPARAM, 'X') <> NVL(V_IDPARAM, 'X')) THEN
         V_DESC := V_DESC ||'Param. Aprova:'  ||''|| NVL(V_IDPARAM,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDPEDIDOOL, 'X') <> NVL(:NEW.IDPEDIDOOL, 'X')) THEN
         V_DESC := V_DESC ||'Gerou Pedido:'  ||''|| NVL(:NEW.IDPEDIDOOL,'')||'   ';
      END IF;
      V_ITPESQ       := :NEW.CDFILSOLI|| :NEW.CDFILLAN|| :NEW.NRSOLICMP|| :NEW.CDPRODUTO|| :NEW.DTPROGENTR;
      V_CDFILLOGOPER := :NEW.CDFILLAN;
      V_IDTIPOOPER   := '2';
   ELSE
      V_DESC   :=        'Filial Dest.'           ||''  || NVL(:NEW.CDFILSOLI,'')       ||'  '  ||
                         'Filial Lan.'           ||''  || NVL(:NEW.CDFILLAN,'')       ||'  '  ||
                         'Nmero'                 ||''  || NVL(:NEW.NRSOLICMP,'')       ||'  '  ||
                         'Produto'                ||''  || NVL(:NEW.CDPRODUTO,'')       ||'  '  ||
                         'Dt. Entr. Item'         ||''  || NVL(:NEW.DTPROGENTR,'')    ||'  '  ||
                         'Oper. Aprova.'          ||''  || NVL(:NEW.CDOPERAPROV,'')     ||'  '  ||
                         'Dt. Ut.'                ||''  || NVL(:NEW.DTUTILIZA,'')    ||'  '  ||
                         'Qt. Itens:'             ||''  || NVL(:NEW.QTSOLIPROD,'')    ||'  '  ||
                         'ID Cons:'               ||''  || NVL(:NEW.IDITMCONS,'')    ||'  '  ||
                         'ID Aprovao:'          ||''  || NVL(:NEW.IDSOLIAPROV,'')    ||'  '  ||
                         'Dt. Aprovao:'         ||''  || NVL(:NEW.DTHRAPROVSOL,'')    ||'  '  ||
                         'Filial OL:'             ||''  || NVL(:NEW.CDFILIOPELOG,'')    ||'  '  ||
                         'Consolidao:'          ||''  || NVL(:NEW.NRSEQUCONSOL,'')   ||'  '  ||
                         'Param. Aprova:'          ||''  || V_IDPARAM   ||'  '  ||
                         'Gerou Pedido:'          ||''  || NVL(:NEW.IDPEDIDOOL,'');

      V_ITPESQ       := :NEW.CDFILSOLI|| :NEW.CDFILLAN|| :NEW.NRSOLICMP|| :NEW.CDPRODUTO|| :NEW.DTPROGENTR;
      V_CDFILLOGOPER := :NEW.CDFILLAN;
      V_IDTIPOOPER   := '1';
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 300);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('ITEMSOLI',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CMP_ITEMSOLI','5.33.XXX'); END;
/
