/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PPAT                                                     */
/* Tabela : PRODPRINATIV                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PPAT' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PPAT
GO

CREATE TRIGGER DTULTATU_PPAT
ON PRODPRINATIV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODPRINATIV', null, 'CDPRODUTO=' + CDPRODUTO + ';'+
                                           'CDPRINATIV='+ CDPRINATIV+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODPRINATIV
      SET DTULTATUPPAT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRODPRINATIV.CDPRODUTO,0) = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(PRODPRINATIV.CDPRINATIV,0)  = ISNULL(INSERTED.CDPRINATIV,0));
   END;
END;
GO

