IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'CURSOR_PADRAO' AND
	        TYPE = 'P'                    AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)

   DROP PROCEDURE CURSOR_PADRAO
   GO

CREATE PROCEDURE CURSOR_PADRAO
  @P_CDPRODUTO     VARCHAR(10),
  @P_CURSOR_PAD    CURSOR VARYING OUTPUT

AS
  SET @P_CURSOR_PAD = CURSOR FORWARD_ONLY STATIC FOR
     SELECT
        RB.CDPRODUTO,  RB.CDSUBPRODUTO, RB.QTSUBPRODROT,
        RB.NRHRFABPROD,RB.NRSEQPROD, RB.IDIMPPRODROT,
        PT.NMPRODUTO,  PT.SGUNIDADE
     FROM
        PRODUTO PT,
        ROTFABRICA RB LEFT JOIN DESCROTEIRO DR
                      ON (RB.CDPRODUTO = DR.CDPRODUTO)
     WHERE
        (RB.CDPRODUTO    = @P_CDPRODUTO  ) AND
        (RB.CDSUBPRODUTO = PT.CDPRODUTO  )
     OPEN @P_CURSOR_PAD
GO
