/* Sistemas Integrados TECNISA

Nome: LOGSERIENFTP.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   05/04/2011 - Kessiler Almeida S. Rodrigues
*/
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_SERIENFTP' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_SERIENFTP
GO
CREATE TRIGGER LOG_SERIENFTP
ON SERIENFTP
FOR UPDATE,INSERT, DELETE
AS
BEGIN
   DECLARE @V_USUARIO             VARCHAR(40);
   DECLARE @V_TIPO                VARCHAR(1);
   DECLARE @V_TPMOVI              VARCHAR(1);
   DECLARE @V_ITPESQ              VARCHAR(40);
   DECLARE @V_DESC                VARCHAR(500);
   DECLARE @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE @V_DSSERVERRDM         VARCHAR(20);
   DECLARE @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE @V_DSREMOTEOPER        VARCHAR(12);

   /* VARIAVEIS DO CURSOR - C_CURSOR */
   DECLARE @V_IDCOMANDO           VARCHAR(1);
   DECLARE @V_CDEMPRESA_OLD       VARCHAR(2);
   DECLARE @V_CDINSCMUNI_OLD      VARCHAR(16);
   DECLARE @V_CDINSCESTA_OLD      VARCHAR(16);
   DECLARE @V_CDSERIE_OLD         VARCHAR(5);
   DECLARE @V_CDTIPOOPER_OLD      VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_OLD    VARCHAR(1);
   DECLARE @V_NRSEQSERIENFTP_OLD  VARCHAR(10);

   DECLARE @V_CDEMPRESA_NEW       VARCHAR(2);
   DECLARE @V_CDINSCMUNI_NEW      VARCHAR(16);
   DECLARE @V_CDINSCESTA_NEW      VARCHAR(16);
   DECLARE @V_CDSERIE_NEW         VARCHAR(5);
   DECLARE @V_CDTIPOOPER_NEW      VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_NEW    VARCHAR(1);
   DECLARE @V_NRSEQSERIENFTP_NEW  VARCHAR(10);

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC WEBTUNNING @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM,@V_DSSERVMETHOD, @V_DSREMOTEOPER;
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
   SET @V_TPMOVI = '0';

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 DELETED.CDEMPRESA,
                 DELETED.CDINSCMUNI,
                 DELETED.CDINSCESTA,
                 DELETED.CDSERIE,
                 DELETED.CDTIPOOPER,
                 DELETED.IDENTRSAIDOP,
                 DELETED.NRSEQSERIENFTP
        FROM DELETED
       WHERE 0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT 'U' IDCOMANDO,
                 INSERTED.CDEMPRESA,
                 INSERTED.CDINSCMUNI,
                 INSERTED.CDINSCESTA,
                 INSERTED.CDSERIE,
                 INSERTED.CDTIPOOPER,
                 INSERTED.IDENTRSAIDOP,
                 INSERTED.NRSEQSERIENFTP,

                 DELETED.CDEMPRESA,
                 DELETED.CDINSCMUNI,
                 DELETED.CDINSCESTA,
                 DELETED.CDSERIE,
                 DELETED.CDTIPOOPER,
                 DELETED.IDENTRSAIDOP,
                 DELETED.NRSEQSERIENFTP
        FROM INSERTED, DELETED
       WHERE INSERTED.NRSEQSERIENFTP = DELETED.NRSEQSERIENFTP
   
      UNION ALL

      SELECT 'I' IDCOMANDO,
                 INSERTED.CDEMPRESA,
                 INSERTED.CDINSCMUNI,
                 INSERTED.CDINSCESTA,
                 INSERTED.CDSERIE,
                 INSERTED.CDTIPOOPER,
                 INSERTED.IDENTRSAIDOP,
                 INSERTED.NRSEQSERIENFTP,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL,
                 NULL
        FROM INSERTED
       WHERE 0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCMUNI_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_CDSERIE_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_IDENTRSAIDOP_NEW,
                                 @V_NRSEQSERIENFTP_NEW,

                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCMUNI_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_CDSERIE_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_IDENTRSAIDOP_OLD,
                                 @V_NRSEQSERIENFTP_OLD;

   WHILE(@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMANDO = 'D' BEGIN
         IF NOT @V_CDEMPRESA_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'Empresa '              +  ISNULL(@V_CDEMPRESA_OLD,    '')    + ' ';
         END;
         IF NOT @V_CDINSCESTA_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'Inscr.Estadual '       +  ISNULL(@V_CDINSCESTA_OLD,   '')    + ' ';
         END;
         IF NOT @V_CDINSCMUNI_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'Inscr.Municipal '      +  ISNULL(@V_CDINSCMUNI_OLD,   '')    + ' ';
         END;
         IF NOT @V_CDSERIE_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod.Srie '            +  ISNULL(@V_CDSERIE_OLD,      '')    + ' ';
         END;
         IF NOT @V_CDTIPOOPER_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod.TpOperao '       +  ISNULL(@V_CDTIPOOPER_OLD,   '')    + ' ';
         END;
         IF NOT @V_IDENTRSAIDOP_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'IdEntrSaidOp '         +  ISNULL(@V_IDENTRSAIDOP_OLD, '')    + ' ';
         END;
         IF NOT @V_NRSEQSERIENFTP_OLD IS NULL BEGIN
            SET @V_DESC = @V_DESC + 'Sequencial '           +  ISNULL(@V_NRSEQSERIENFTP_OLD, '');
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_CDEMPRESA_OLD+@V_CDINSCESTA_OLD+@V_CDINSCMUNI_OLD+@V_CDSERIE_OLD+@V_CDTIPOOPER_OLD+@V_IDENTRSAIDOP_OLD+@V_NRSEQSERIENFTP_OLD;
      END
      ELSE BEGIN
         IF @V_IDCOMANDO = 'U' BEGIN
            IF (ISNULL(@V_CDEMPRESA_OLD,'!')    <> ISNULL(@V_CDEMPRESA_NEW,'!'))    OR
               (ISNULL(@V_CDINSCESTA_OLD,'!')   <> ISNULL(@V_CDINSCESTA_NEW,'!'))   OR
               (ISNULL(@V_CDINSCMUNI_OLD,'!')   <> ISNULL(@V_CDINSCMUNI_NEW,'!'))   OR
               (ISNULL(@V_CDSERIE_OLD,'!')      <> ISNULL(@V_CDSERIE_NEW,'!'))      OR
               (ISNULL(@V_CDTIPOOPER_OLD,'!')   <> ISNULL(@V_CDTIPOOPER_NEW,'!'))   OR
               (ISNULL(@V_IDENTRSAIDOP_OLD,'!') <> ISNULL(@V_IDENTRSAIDOP_NEW,'!')) OR
               (ISNULL(@V_NRSEQSERIENFTP_OLD, '!') <> ISNULL(@V_NRSEQSERIENFTP_NEW, '!')) BEGIN
                  SET @V_TIPO = '2';
                  SET @V_ITPESQ = ISNULL(@V_CDEMPRESA_OLD, '')+ISNULL(@V_CDINSCESTA_OLD, '')+ISNULL(@V_CDINSCMUNI_OLD, '')+ISNULL(@V_CDSERIE_OLD, '')+ISNULL(@V_CDTIPOOPER_OLD, '')+ISNULL(@V_IDENTRSAIDOP_OLD, '')+ISNULL(@V_NRSEQSERIENFTP_OLD, '');
            END;
         END
         ELSE BEGIN
            IF @V_IDCOMANDO = 'I' BEGIN
               SET @V_TIPO = '1';
               SET @V_ITPESQ = @V_CDEMPRESA_NEW+@V_CDINSCESTA_NEW+@V_CDINSCMUNI_NEW+@V_CDSERIE_NEW+@V_CDTIPOOPER_NEW+@V_IDENTRSAIDOP_NEW+@V_NRSEQSERIENFTP_NEW;
            END;
         END;
         IF ISNULL(@V_CDEMPRESA_OLD,'!')    <> ISNULL(@V_CDEMPRESA_NEW,'!')    BEGIN
            SET @V_DESC = @V_DESC + 'Empresa '       +  ISNULL(@V_CDEMPRESA_NEW,    '')      + ' ';
         END;
         IF ISNULL(@V_CDINSCESTA_OLD ,'!')   <> ISNULL(@V_CDINSCESTA_NEW ,'!')  BEGIN
            SET @V_DESC = @V_DESC + 'Inscr.Estadual '  +  ISNULL(@V_CDINSCESTA_NEW,   '')    + ' ';
         END;
         IF ISNULL(@V_CDINSCMUNI_OLD ,'!')   <> ISNULL(@V_CDINSCMUNI_NEW,'!')   BEGIN
            SET @V_DESC = @V_DESC + 'Inscr.Municipal ' +  ISNULL(@V_CDINSCMUNI_NEW,   '')    + ' ';
         END;
         IF ISNULL(@V_CDSERIE_OLD ,'!')      <> ISNULL(@V_CDSERIE_NEW ,'!')     BEGIN
            SET @V_DESC = @V_DESC + 'Cod.Srie '       +  ISNULL(@V_CDSERIE_NEW,      '')    + ' ';
         END;
         IF ISNULL(@V_CDTIPOOPER_OLD ,'!')   <> ISNULL(@V_CDTIPOOPER_NEW,'!')   BEGIN
            SET @V_DESC = @V_DESC + 'Cod.TpOperao '  +  ISNULL(@V_CDTIPOOPER_NEW,   '')    + ' ';
         END;
         IF ISNULL(@V_IDENTRSAIDOP_OLD ,'!') <> ISNULL(@V_IDENTRSAIDOP_NEW,'!') BEGIN
            SET @V_DESC = @V_DESC + 'IdEntrSaidOp '     +  ISNULL(@V_IDENTRSAIDOP_NEW, '')   + ' ';
         END;
         IF ISNULL(@V_NRSEQSERIENFTP_OLD, '!') <> ISNULL(@V_NRSEQSERIENFTP_NEW, '!') BEGIN
            SET @V_DESC = @V_DESC + 'Sequencial '       + ISNULL(@V_NRSEQSERIENFTP_NEW, '');
         END;
      END;
      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('SERIENFTP',  GETDATE(), @V_USUARIO,
                   @V_TIPO,         @V_ITPESQ, @V_DESC,
                   @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM,
                   @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_IDCOMANDO,
                                    @V_CDEMPRESA_NEW,
                                    @V_CDINSCMUNI_NEW,
                                    @V_CDINSCESTA_NEW,
                                    @V_CDSERIE_NEW,
                                    @V_CDTIPOOPER_NEW,
                                    @V_IDENTRSAIDOP_NEW,
                                    @V_NRSEQSERIENFTP_NEW,

                                    @V_CDEMPRESA_OLD,
                                    @V_CDINSCMUNI_OLD,
                                    @V_CDINSCESTA_OLD,
                                    @V_CDSERIE_OLD,
                                    @V_CDTIPOOPER_OLD,
                                    @V_IDENTRSAIDOP_OLD,
                                    @V_NRSEQSERIENFTP_OLD;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_SERIENFTP','5.20.xxx';
GO