<?php

namespace Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calendar;

/**
 * Interface EntityInterface for entities project and task
 * @package Service\Calendar
 */
interface TaskCalendarInterface{

    public function getAllCalendars();
    public function getRestriction();

    public function getParentsCalendar();

    public function getId();

    /**
     * @return boolean
     */
    public function needScheduleCalcDates();
    public function hasTaskRelationship();
    public function getTaskRelationship();

    /**
     * @param $restriction
     * @return mixed
     */
    public function setRestriction($restriction);
    public function getDateExceptionType();
    public function getTaskRelationshipInverse();
    public function directChildren();
    /** @return \Datetime */
    public function setEstimatedBeginDate();
    /** @return \Datetime */
    public function setEstimatedEndDate();
    /** @return \Datetime */
    public function getEstimatedBeginDate();
    /** @return \Datetime */
    public function getEstimatedEndDate();
    public function setDurationPrecursor($durationPrecursor);
    public function getDurationPrecursor();
    public function usesDataControl();
    public function setNeedScheduleCalcDates($needScheduleCalcDates);
    public function isIssue();
    public function isContainer();
    public function hasChildren();
    public function children();
    public function getEstimatedBeginDateMinParents();
    public function getEstimatedEndDateMaxParents();
    public function getDuration();
    public function getTimePlanned();
    public function getPreviousTime();
    /** @return  TaskCalendarInterface */
    public function getTreeParent();

    /** @return \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project */
    public function getProject();
    public function getInCalc();
    public function setInCalc($inCalc);
    public function setLatency($latency);
    public function getLatency();
    public function setDuration();
    public function getDateException();
    /** @return  TaskCalendarInterface */
    public function getParent();
}